package com.cloudcross.ssp.common.consts;

import java.util.Arrays;
import java.util.List;

/**
 * <code>HttpResponse</code>响应内容格式。
 */
public interface HttpContentType {
		/**
		 * HTML
		 * <p>
		 * 后缀名：*.htm *.html *.shtml
		 */
		String HTML = "text/html";

		/**
		 * TXT
		 * <p>
		 * 后缀名：*.txt
		 */
		String TXT = "text/plain";

		/**
		 * XML
		 * <p>
		 * 后缀名：*.xml
		 */
		String XML = "text/xml";

		/**
		 * ZIP
		 * <p>
		 * 后缀名：*.zip
		 */
		String ZIP = "application/zip";
		
		/**
		 * IMG
		 * <p>
		 * 后缀名：*.png
		 */
		List<String> IMG_PNG = Arrays.asList("image/x-png","image/png");
		
		/**
		 * IMG
		 * <p>
		 * 后缀名：*.jpg或*.jpeg
		 */
		List<String> IMG_JPG = Arrays.asList("image/pjpeg","image/jpeg");
		
		/**
		 * SWF代表flash类型 
		 * <p>
		 * 后缀名：*.swf
		 */
		String SWF = "application/x-shockwave-flash";
		
}
