package com.cloudcross.ssp.service;

import java.util.List;
import java.util.Map;

import com.cloudcross.ssp.base.service.IGenericService;
import com.cloudcross.ssp.model.PlaceClassInformation;


/**
 * 数聚场景服务接口定义
 * @author chenyou
 *
 */
public interface IPlaceClassInformationService extends IGenericService<PlaceClassInformation> {
	
	/**
	 * 根据运营商查找与这个运营商对应的数聚场景
	 * @param operatorId
	 * @return
	 */
	List<PlaceClassInformation> findPlaceClassByOperatorId();
	
	/**
	 * 查找所有的数聚场景
	 * @return
	 */
	List<PlaceClassInformation> findAll();
	
	
	List<PlaceClassInformation> queryPlaceClassInformationByAdgroupId(Long adgroupId);
	
	public List<Long>queryPlaceClassIndfoIdByAdgroupId(Long adgroupId);
	
	public Integer queryPlaceClassCount();
	
	public List<PlaceClassInformation> queryPlaceClass(Map<String,Object>condition);
}
