<@override name="head">
<title>财务管理</title>
<link rel="stylesheet" href="${ctx}/assets/css/daterangepicker.css" />

<script type="text/javascript" src="${ctx}/assets/js/lib/moment.min.js"></script>
<script type="text/javascript" src="${ctx}/assets/js/lib/jquery.daterangepicker.js"></script>
<script type="text/javascript" src="${ctx}/assets/js/lib/date.js"></script>
<script type="text/javascript" src="${ctx}/assets/js/common/table.js"></script>
<script type="text/javascript" src="${ctx}/assets/js/common/dropDownList.js"></script>
<script type="text/javascript" src="${ctx}/assets/js/common/shortcutkey_datePicker.js"></script>
<script type="text/javascript" src="${ctx}/assets/js/advertiser/finance.js"></script>
</@override>
<@override name="body">
<div id=content_bg>
	<#include "/advertiser/main/public-head.ftl">
    <div id= "pagecontent">
    	<div id="contentOther">
   			<div id="navDiv">
				<ul id="navDiv_ul">
					<li><i class="icon-home"></i></li>
					<li><a href="${ctx}/advertiser/main/dashboard">首页</a></li>
					<li><i class="icon-angle-right"></i></li>
				    <li><a href="${ctx}/advertiser/main/finance/adv-balance/list">财务管理</a></li>
				    <li><i class="icon-angle-right"></i></li>
				    <li class="navDiv_currentLi">广告主消费记录</li>
				</ul>  
 			</div>
 			<form id="myform" action="${ctx}/advertiser/main/finance/adv-balance/list" method="post">
 				<input id="page" name="page" type="hidden" value="${pager.page}"/>
 				<div id="navButtons">
					<div id="button">					
						<a href="${ctx}/advertiser/main/finance/adv-balance/list" class="btn2">广告主消费记录</a>
						<a href="${ctx}/advertiser/main/finance/finance-data/list" class="btn2">资金管理</a>
						<a href="${ctx}/advertiser/main/finance/adv-balance/distribution" class="btn2">广告主分配记录</a>
					</div>
				</div>
				<div id="selectuls">
					<div class="selectuls_finance_div">
						<span class="selectuls_finance_span">广告主：</span>
						<ul id="main_advertiserul">
							<li class="select_box" id="advertiserul_box">
								<span id="advertiserul_span">${selectedAdvertiserName!}</span>
								<ul class="son_ul" id="advertiser_son_ul"></ul>
							</li>
						</ul>
						<input type="hidden" name="selectedAdvertiserId" id="advertiserId" value="${advertiserId!}">
						<input type="hidden" name="selectedAdvertiserName" id="advertiserName" value="${selectedAdvertiserName!}">
					</div>
					<div class="selectuls_finance_div">
						<span class="selectuls_finance_span">查看周期：</span>
						<span id="calendar_span">
							<i class="icon-calendar"></i>   
							<input type="text" name="dateRangePicker" id="dateRangePicker" value="${dateRangePicker!}" readonly/>
						</span>
					</div>
					<div class="selectuls_finance_div">
						<span class="selectuls_finance_span">操作类型：</span>
						<ul id="main_typeul">
							<li class="select_box" id="typeul_select_box">
								<span id="typeul_span">${typeName!}</span>
								<ul class="son_ul" id="type_son_ul">
									<li typeValue="0">请选择操作类型</li>
									<li typeValue="charge">充值</li>
									<li typeValue="consume">消费</li>
									<li typeValue="allocate">分配</li>
								</ul>
							</li>
						</ul>
						<input type="hidden" name="type" id="typeId" value="${type!}">
						<input type="hidden" name="typeName" id="typeName" value="${typeName!}">
					</div>
					<input id="btn_formSubmit" type="submit" value="查询"/>
					<a id="btn_formExport" href="javascript:void(0);" onClick="exportExcel_list()">导出Excel</a>
				</div>
				<table border="1" class="tableFig">
					<thead>
						<tr class="theadTr">
							<th class="theadTh" style="width:5%;"><div class="checkboxStyleTh"></div></th>
							<th class="theadTh" style="width:10%;">时间</th>
							<#if role == "agent">
							<th class="theadTh" style="width:15%;">代理商</th>
							<#elseif role == "advertiser">
							<th class="theadTh" style="width:15%;">广告主</th>
							</#if>
							<th class="theadTh" style="width:20%;">交易号</th>
							<th class="theadTh" style="width:10%;">费用类型</th>
							<th class="theadTh" style="width:15%;">金额（元）</th>
							<th class="theadTh" style="width:15%;">余额（元）</th>
						</tr>
				    </thead>
				    <tbody>
						<#if advBalanceList ??>
				        <#list advBalanceList as advBalance>
				        <tr id="tbodyTr">
							<td class="tbodyTd"><div class="checkboxStyleTd" id="${advBalance.id!}"></div></td>
							<td class="tbodyTd">${advBalance.actTime!?date}</td>
							<#if role == "agent">
							<td class="tbodyTd">${agentName!}</td>
							<#elseif role == "advertiser">
							<td class="tbodyTd">${advBalance.advertiserName!}</td>
							</#if>
							<td class="tbodyTd">${advBalance.num!}</td>
							<td class="tbodyTd">${advBalance.type!}</td>
							<td class="tbodyTd">${advBalance.cash!}</td>
							<td class="tbodyTd">${advBalance.balance!}</td>
						</tr>
				        </#list>
						</#if>           
				    </tbody>
				</table>
				<div id="pageDiv-other">
					<#include "/common/pagination/simple.ftl"/>
				</div>
 			</form>
		</div>
	</div>
</div>
</@override>
<@extends name="/common/simple.ftl"/>